<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

error_reporting(0);

$version = "0.3.1";
$output_dir = "/var/lib/lms-subsys-ftpsearch/";

require("/etc/lms/main.php");

if ( $config[xoops_output] )
{
	$result = "<?php
include('$config[xoops_path]/mainfile.php');
include_once(XOOPS_ROOT_PATH.'/class/xoopscomments.php');

if ( !\$xoopsUser ) {
	redirect_header('index.php',3,_US_NOEDITRIGHT);
	exit();
}

define(\"XOOPS_HEADER_INCLUDED\",1);
xoops_header(false);

echo(\"<meta http-equiv='refresh' content=600 url='.'>\n</head>\");

\$currenttheme = getTheme();
include(XOOPS_ROOT_PATH.\"/themes/\".\$currenttheme.\"/theme.php\");
if ( file_exists(XOOPS_ROOT_PATH.\"/themes/\".\$currenttheme.\"/language/lang-\".\$xoopsConfig['language'].\".php\") ) {
	include(XOOPS_ROOT_PATH.\"/themes/\".\$currenttheme.\"/language/lang-\".\$xoopsConfig['language'].\".php\");
} elseif ( file_exists(XOOPS_ROOT_PATH.\"/themes/\".\$currenttheme.\"/language/lang-english.php\") ) {
	include(XOOPS_ROOT_PATH.\"/themes/\".\$currenttheme.\"/language/lang-english.php\");
}
\$xoopsOption['show_rblock'] = (!empty(\$xoopsOption['show_rblock'])) ? \$xoopsOption['show_rblock'] : 0;
themeheader(\$xoopsOption['show_rblock']);

OpenTable();
echo \"
	";
}
else
{
	$result = "<html>\n<head><meta http-equiv='refresh' content=600 url='.'></head>\n<body>";
}

define('DFTK_ROOT_PATH', "/usr/share/dftk/");
define('LMS_ROOT_PATH', "/usr/share/lms-core-api/");

require_once(LMS_ROOT_PATH."inc.php");
require_once(LMS_ROOT_PATH."hosts/inc.php");

$langmgr =& new DftkDaLanguageManager();
$resultmgr =& new DftkDaTraceManager($langmgr);

$con =& new DftkLdapConnection($resultmgr);
$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");

$r =& $con->connect($config[server], true);
if (!$r->has_error())
{
	$r =& $con->bind($config[login], $config[passwd]);
	if (!$r->has_error())
	{
		$hostmgr =& new LmsHostManager($resultmgr, $con);

		$hosts = find_hosts($hostmgr);
		if (count($hosts)>0)
		{
			$result.= "<CENTER>";
			$result.= "<H1>Servers FTP Actifs sur le LAN</H1>";
			$result.="<H2>Cette page est gnre et automatiquement rafraichie toutes les 10 min<BR>\n";
			$result.="(dernire mise  jour : ".date("Y-m-d H:i:s").")</H2>\n";
			$result.="<H3>\n";
			for ($i=0; $i<count($hosts); $i++)
			{
				//if (ftp_connect($hosts[$i][ip], 21, 1))
				if (ftp_connect($hosts[$i][ip], 21))
				{
					$result.="<A href='ftp://".$hosts[$i][hostname].".coinnetwork.dl/'>".$hosts[$i][hostname]."</A><BR>\n";
				}
			}
			$result.="</H3><BR><HR>\n";
			$result.="<H3>LMS SUBSYS-FTPSEARCH V".$version." <BR> Copyright &copy;2002-2003 DuckCorp&#153; and RtpNet&#153;</H3>\n";
			$result.="<H4>This program is free software; you can redistribute it and/or modify it under the terms<BR>";
			$result.="of the GNU General Public License as published by the <A href='http://www.fsf.org/'>Free Software Foundation</A>.</H4>";
			$result.="</CENTER>";
			if ( $config[xoops_output] )
			{
				$result.="\";
				CloseTable();
				include(XOOPS_ROOT_PATH.'/footer.php');
				?>";
			}
			else
			{
				$result.="</body></html>";
			}

			$fp = fopen($output_dir."/index.php.build" ,"w");
			fwrite($fp, $result);
			fclose($fp);
			rename($output_dir."/index.php.build", $output_dir."/index.php");
		}
	}
	else
		print($r->get_debug_msg(true));

	$con->disconnect();
}
else
	print($r->get_debug_msg(true));

unset($con);



function find_hosts(&$hostmgr)
{
	$tab = array();
	$tabi = 0;

	$r =& $hostmgr->get_list(LMS_HTYPE_UNKNOWN, array('iphostnumber'));
	if (!$r->has_error())
	{
		$hostmgr->sort_result_by_attr('cn');
		$nb = $r->get_result('count');
		if ($nb>0)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$r =& $hostmgr->select_result($i);
				$iplist = $r->get_result('iphostnumber');
				$nbip = count($iplist);
				if ($nbip>0)
				{
					for ($j=0; $j<$nbip; $j++)
					{
						if ($iplist[$j]!="0.0.0.0")
						{
							$tab[$tabi][hostname] = strtolower($r->get_result('cn'));
							$tab[$tabi][ip] = $iplist[$j];
							$tabi++;
							break;
						}
					}
				}
			}
			return $tab;
		}
		else
			print("####### No Host found #######\n");
	}
	else
		print($r->get_debug_msg(true));

	return null;
}

?>
